/******************************************************************************
;  *   	@MCU   	   	   	   	 : MC32P7311
;  *   	@Create Date         : 2019.12.23
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2019 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	   	   	  P04 P11 P12  	ADɼ
   	   	   	   	   	   	  P17 200msת T0ж
******************************************************************************/	

#include "user.h"

/************************************************
;  *    @Function Name       : C_RAM
;  *    @Description         : ʼRAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
   	for (FSR0 = 0; FSR0 < 0xff; FSR0++)
   	{
   	   	INDF0 = 0x00;
   	}
   	FSR0 = 0xFF;
   	INDF0 = 0x00;
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
   	IOP0 = 0x00;   //ioλ
   	OEP0 = 0xEF;   //ioڷ 1:out  0:in   P001Ϊ©
   	PUP0 = 0x00;   //io   1:enable  0:disable
   	PDP0 = 0x00;   //io   1:enable  0:disable
   	ANSEL0 = 0x00; //ioѡ  1:ģ  0:ͨio

   	IOP1 = 0x00;   //ioλ
   	OEP1 = 0xf9;   //ioڷ 1:out  0:in   P13Ϊ©
   	PUP1 = 0x00;   //io   1:enable  0:disable
   	PDP1 = 0x00;   //io   1:enable  0:disable
   	ANSEL1 = 0x00; //ioѡ  1:ģ  0:ͨio

   	DRVCR = 0x80;
}
/************************************************
;  *    @Function Name       : ADC_Config
;  *    @Description         : ADCʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Init(void)
{
   	ANSEL0 |= 0xc8; //P04 P11  P12 3  6  7  ģ  1 ģ  0  IO
   	ADCR0 &= 0x07;
   	ADCR0 |= 0x78; //ͨ7  12λ
   	ADCR1 &= 0x00;
   	ADCR1 |= 0xe1; //125K  ڲ3V
   	ADCR2 = 0xff; //ĬϹ̶15ʱ
   	ADON = 1; //ʹADC
}
/************************************************
;  *    @Function Name       : ADC_Get_Value
;  *    @Description         : ADCת
;  *    @IN_Parameter      	 : CHX  ADCͨ
;  *    @Return parameter    : 
;  ***********************************************/
void ADC_Get_Value(u8 CHX)
{
   	ADCR0 = (ADCR0 & 0x0f) | (CHX << 4); // ADC ʹ  ADתͨ  ͨ  CHX

   	if (changl_num != CHX) //ͨл  ȥ
   	{
   	   	changl_num = CHX;
   	   	ADEOC = 0; // ʼת
   	   	while (ADEOC == 0)
   	   	{ // EOCı־λ   ȴת
   	   	}
   	}
   	ADEOC = 0; // ʼת
   	while (ADEOC == 0)
   	{ // EOCı־λ   ȴת
   	}
   	ADC_num_temp = ADRH;
   	ADC_num_temp = ADC_num_temp << 4;
   	ADC_num_temp |= (ADRL & 0x0f);
}
/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
   	T0CR |= 0x84; //Fcpu 16
   	T0CNT = 249;
   	T0LOAD = 249;  	   //1ms
   	T0IE = 1;
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	TIMER0_INT_Init();
   	ADC_Init();
   	GIE = 1;
}
void main(void)
{
   	Sys_Init();
   	while (1)
   	{
   	   	ADC_Get_Value(3);
   	   	ADC_Get_Value(6);
   	   	ADC_Get_Value(7);
   	}
}

void int_isr(void) __interrupt
{
__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
__endasm;
   	//=======T0========================
   	if (T0IF & T0IE)
   	{
   	   	T0IF = 0;
   	   	timer0_num++;
   	   	if (timer0_num >= 200) 	   	   	//200ms
   	   	{
   	   	   	timer0_num = 0;
   	   	   	P17D = !P17D;
   	   	}
   	}

   	//òжϿɾ  ԼROM
   	//=======T1========================
   	if (T1IF & T1IE)
   	{
   	   	T1IF = 0;
   	}
   	//=======T2========================
   	if (T2IF & T2IE)
   	{
   	   	T2IF = 0;
   	}
   	//=======T3========================
   	if (T3IF & T3IE)
   	{
   	   	T3IF = 0;
   	}
   	//=============================
   	if (KBIF & KBIE)
   	{
   	   	KBIF = 0;
   	}
   	//=======ADC=======================
   	if (ADIF & ADIE)
   	{
   	   	ADIF = 0;
   	}
   	//=======ⲿж0=================
   	if (INT0IF & INT0IE)
   	{
   	   	INT0IF = 0;
   	}
   	//=======ⲿж1=================
   	if (INT1IF & INT1IE)
   	{
   	   	INT1IF = 0;
   	}
__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
__endasm;
}
